package sd201311.handwriting;

import java.util.ArrayList;

import sd201311.handwriting.Fragment.WritingFragment;
import android.os.Bundle;
import android.annotation.SuppressLint;
import android.app.ActionBar;
import android.app.Activity;
import android.content.res.Configuration;
import android.support.v4.app.ActionBarDrawerToggle;
import android.support.v4.widget.DrawerLayout;
import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListView;
import android.widget.Toast;

public class MainActivity extends Activity {
    private String mLoadFileName;		// I𒆂̃t@C
    private String[] mFileNameList;		// t@C̃Xg

    // ListViewCX^X
    private ListView mDrawerList;
    // DrawerLayoutCX^X
    private DrawerLayout mDrawerLayout;
    // ActionBarDrawerToggleCX^X
    private ActionBarDrawerToggle mDrawerToggle;
    
	/**
	 * onCreate
	 */
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        
		// Navigation DrawerListView̐
		mDrawerList = (ListView) findViewById(R.id.navi_drawer);
		// XgڑICxg̓o^
		mDrawerList.setOnItemClickListener(new DrawerItemClickListener());
		// DrawerLayout̎擾
		mDrawerLayout = (DrawerLayout) findViewById(R.id.drawer_layout);
		// t@CXg̓ǂݍ
		ReLoadFileList();
		
		// ACRAbvirQ[VƂĐݒ肷
		ActionBar actionBar = getActionBar();
		actionBar.setDisplayHomeAsUpEnabled(true);
		actionBar.setHomeButtonEnabled(true);
		
		// ActionBarDrawerToggle̐
		mDrawerToggle = new ActionBarDrawerToggle(
				this, mDrawerLayout,
				android.R.drawable.ic_menu_sort_by_size,
				//̍s R.drawable.ic_drawer ɂ
				R.string.drawer_open, R.string.drawer_close ) {
		
			/**
			 * Xg\
			 * @param view view
			 */
			public void onDrawerClosed(View view) {
				// ANVo[̃^Cgݒ
				getActionBar().setTitle(mLoadFileName);
				// j[ڕ\ؑ
				invalidateOptionsMenu();
			}
			
			/**
			 * Xg\
			 * @param drawerView drawerView
			 */
			public void onDrawerOpened(View drawerView) {
				// XgĐݒ
				ReLoadFileList();
				// ANVo[̃^Cgݒ
				getActionBar().setTitle(mLoadFileName);
				// j[ڕ\ؑ
				invalidateOptionsMenu();
			}
		};
		// DrawerLayoutɐݒ肷
		mDrawerLayout.setDrawerListener(mDrawerToggle);
		// XCvŃXg\Ȃ悤ɃbN
		// 菑ɈӐ}Ȃ^C~OŃXg\̂h
		//mDrawerLayout.setDrawerLockMode(
		//	DrawerLayout.LOCK_MODE_LOCKED_CLOSED);
    }

	/**
	 * IvVj[̐
	 */
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
		MenuInflater inflater = getMenuInflater();
		// XMLŒ`menuw肷
		inflater.inflate(R.menu.main, menu);
		return true;
    }
    
	/**
	 * Xg\̃j[\ؑ
	 * @param menu j[
	 * @return 
	 */
	@Override
	public boolean onPrepareOptionsMenu(Menu menu) {
		// Xg\ԂɂȂĂ邩ǂ
		boolean drawerOpen = mDrawerLayout.isDrawerOpen(mDrawerList);
		// Xg\ԂȂAANVo[ƃj[̍ڂ\Ȃ悤ɂ
		menu.findItem(R.id.menu_new).setVisible(!drawerOpen);
		menu.findItem(R.id.menu_save).setVisible(!drawerOpen);
		menu.findItem(R.id.menu_delete).setVisible(!drawerOpen);
		return super.onPrepareOptionsMenu(menu);
	}
    
	/**
	 * IvVj[̑I
	 */
	@SuppressLint("DefaultLocale")
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// ACR{^͂ŏ
		if (mDrawerToggle.onOptionsItemSelected(item)) {
			return true;
		}
        
		// IDWritingFragment擾
		WritingFragment fragment = (WritingFragment)getFragmentManager()
				.findFragmentById(R.id.drawfragment);
		
		int itemId = item.getItemId();
		switch (itemId) {
			// VK
			case R.id.menu_new:
				// `NA
				if(!fragment.ClearDraw()){
				    // ʂNAĕ̂ŁAsꍇ̂݃bZ[W\
				    Toast.makeText(this, getString(R.string.mes_new_err),
				    		Toast.LENGTH_SHORT).show();
				} else {
				    // t@C\̍폜
				    mLoadFileName = null;
				    getActionBar().setTitle(mLoadFileName);
				}
				break;
			// ۑ
			case R.id.menu_save:
			    // ۑ20𒴂ꍇ
				if(mFileNameList.length >= 20){
					Toast.makeText(this, getString(R.string.mes_save_max_err),
							Toast.LENGTH_SHORT).show();
					break;
				}

				String saveFileName = mLoadFileName;
				// t@Cݒ肳ĂȂꍇ
				if(mLoadFileName == null){
					// t@CNo̍ől߂
					int maxFileNo = 0;
					for (String fileTitle : mFileNameList) {
						int no = 0;
						try {
							no = Integer.parseInt(fileTitle.substring(4, 7));
						} catch (Exception e) {
							e.printStackTrace();
							Log.e("menu_save", e.getMessage());
						}
	
						if (maxFileNo < no) {
							maxFileNo = no;
						}
					}
				
					// ől+1t@CNoƂ
					saveFileName 
						= String.format("Note%1$03d.png", (maxFileNo + 1));
				}
	
				// t@Cۑ
				if(fragment.SaveBitmap(saveFileName)){
				    Toast.makeText(this, getString(R.string.mes_save),
				    		Toast.LENGTH_SHORT).show();
	
					// t@C\̐ݒ
					mLoadFileName = saveFileName;
					getActionBar().setTitle(mLoadFileName);
		
					// XgĐݒ
					ReLoadFileList();
				} else {
					Toast.makeText(this, getString(R.string.mes_save_err), 
							Toast.LENGTH_SHORT).show();
				}
				break;
			// 폜
			case R.id.menu_delete:
				// 폜̓t@CIς݂̏ꍇɎsł
				if(mLoadFileName != null
					&& fragment.DeleteBitmap(mLoadFileName)){
					Toast.makeText(this, getString(R.string.mes_del),
							Toast.LENGTH_SHORT).show();
				
					// 폜̂ŁAt@C\̍폜ƁA`NA
					mLoadFileName = null;
					getActionBar().setTitle(mLoadFileName);
					fragment.ClearDraw();
		
					// XgĐݒ
					ReLoadFileList();
				} else {
					Toast.makeText(this, getString(R.string.mes_del_err),
							Toast.LENGTH_SHORT).show();
				}
				break;
		}
		return true;
	}

	/**
	 * Xg̍ēǂݍ
	 */
	private void ReLoadFileList() {
		// t@Cǂݍ
		mFileNameList = fileList();

		if(mFileNameList == null) 
		{
			mFileNameList = new String[0];
		}
		
		ArrayList<BindData> dataObj = new ArrayList<BindData>();
		for(int i = 0; i < mFileNameList.length; i++){
			// 摜t@C^CgɁATvƂă`[ACR摜^CgACRɐݒ
			dataObj.add(new BindData(mFileNameList[i],R.drawable.ic_launcher));
		}
		
		// XgɍĐݒ肷
		mDrawerList.setAdapter(
				new NaviDrawerAdapter(getApplicationContext(), dataObj));
		
        /* JX^AdapterNXgȂꍇ(drawer_list_itemɂTextVieŵ݂̏ꍇ)
        // XgɍĐݒ肷
        mDrawerList.setAdapter(new ArrayAdapter<String>(
        		getApplicationContext(),
                R.layout.drawer_list_item, mFileNameList));
        */
	}
	
	/**
	 * XgڑICxgXi[
	 */
	private class DrawerItemClickListener
		implements ListView.OnItemClickListener {
	    @Override
	    public void onItemClick(AdapterView<?> parent, 
	    		View view, int position, long id) {
	        SelectedItem(position);
	    }
	}
	
	/**
	 * XgڑI
	 * @param pos ڈʒu
	 */
	private void SelectedItem(int pos) {
		// WritingFragment擾
		WritingFragment fragment
			= (WritingFragment)getFragmentManager().findFragmentById(
					R.id.drawfragment);
		// It@C[h
		fragment.LoadBitmap(mFileNameList[pos]);
		
		// Iڂ̃`FbNݒ
		mDrawerList.setItemChecked(pos, true);
		// ^Cgݒ
		setTitle(mFileNameList[pos]);
		// Xg\ɂ
		mDrawerLayout.closeDrawer(mDrawerList);
	}
	
	 /**
	 * ^Cgݒ
	 * @param title ^Cg
	 */
	@Override
	public void setTitle(CharSequence title) {
		// [ht@CƂĕێ
		mLoadFileName = title.toString();
		// ANVo[̃^CgɃt@C\
		getActionBar().setTitle(mLoadFileName);
	}
	
	/**
	 * onStartonRestoreInstanceStatěďȍ
	 * @param savedInstanceState savedInstanceState
	 */
	@Override
	protected void onPostCreate(Bundle savedInstanceState) {
		super.onPostCreate(savedInstanceState);
		// ԂDrawerLayoutsync
		mDrawerToggle.syncState();
	}
	
	/**
	 * foCX̏(]ԂȂ)̕ύXCxg
	 * @param newConfig newConfig
	 */
	@Override
	public void onConfigurationChanged(Configuration newConfig) {
		super.onConfigurationChanged(newConfig);
		// onConfigurationChanged͂̃\bhłĂяoKv
		mDrawerToggle.onConfigurationChanged(newConfig);
	}
}
